# Debian / non-UBI
# included when not a UBI/FIPS pipeline, branch, tag

## phase zero

alpine-stable:
  extends: .job-base
  stage: phase-zero
  script:
    - record_stable_image "${DEPENDENCY_PROXY}${ALPINE_IMAGE}"

debian-stable:
  extends: .job-base
  stage: phase-zero
  script:
    - record_stable_image "${DEPENDENCY_PROXY}${DEBIAN_IMAGE}"

gitlab-base:
  extends: .gitlab-base
  needs:
     - debian-stable
     - gitlab-logger
     - gitlab-gomplate

gitlab-go:
  extends: .gitlab-go
  needs:
    - debian-stable

gitlab-rust:
  extends: .gitlab-rust
  needs:
    - debian-stable

## phase one

certificates:
  extends: .certificates
  needs:
    - gitlab-base

cfssl-self-sign:
  extends: .cfssl-self-sign
  needs:
    - alpine-stable

kubectl:
  extends: .kubectl
  needs:
    - debian-stable

gitlab-gomplate:
  extends: .gitlab-gomplate
  needs:
    - debian-stable

gitlab-graphicsmagick:
  extends: .gitlab-graphicsmagick
  needs:
    - debian-stable

gitlab-exiftool:
  extends: .gitlab-exiftool
  needs:
    - gitlab-base

gitlab-python:
  extends: .gitlab-python
  needs:
    - debian-stable

gitlab-ruby:
  extends: .gitlab-ruby
  needs:
   - gitlab-base
   - gitlab-rust

postgresql:
  extends: .postgresql
  needs:
    - debian-stable

## phase two

gitlab-exporter:
  extends: .gitlab-exporter
  needs:
    - gitlab-ruby

gitlab-mailroom:
  extends: .gitlab-mailroom
  needs:
    - gitlab-ruby

## phase three

gitlab-logger:
  extends: .gitlab-logger
  needs:
    - gitlab-go

## phase four

gitaly:
  extends: .gitaly
  needs:
   - gitlab-go
   - gitlab-ruby

gitlab-container-registry:
  extends: .gitlab-container-registry
  needs:
    - gitlab-base
    - gitlab-go

gitlab-zoekt-webserver:
  extends: .gitlab-zoekt-webserver
  needs:
    - gitlab-base
    - gitlab-go

gitlab-zoekt-dynamic-indexserver:
  extends: .gitlab-zoekt-dynamic-indexserver
  needs:
    - gitlab-base
    - gitlab-go

gitlab-elasticsearch-indexer:
  extends: .gitlab-elasticsearch-indexer
  needs:
    - gitlab-go

gitlab-metrics-exporter:
  extends: .gitlab-metrics-exporter
  needs:
    - gitlab-go

gitlab-kas:
  extends: .gitlab-kas
  needs:
  - gitlab-go

gitlab-pages:
  extends: .gitlab-pages
  needs:
    - gitlab-base
    - gitlab-go

gitlab-shell:
  extends: .gitlab-shell
  needs:
    - gitlab-base
    - gitlab-go

## phase five

gitlab-rails-ee:
  extends: .gitlab-rails-ee
  needs:
    - postgresql
    - gitlab-graphicsmagick
    - gitlab-exiftool
    - gitlab-ruby
    - gitlab-rust
    - gitlab-elasticsearch-indexer
    - gitlab-metrics-exporter
  variables:
    IMAGE_FLAVOR: 'debian'

gitlab-rails-ce:
  extends: .gitlab-rails-ce
  needs:
    - postgresql
    - gitlab-graphicsmagick
    - gitlab-exiftool
    - gitlab-ruby
    - gitlab-rust
    - gitlab-metrics-exporter
  variables:
    IMAGE_FLAVOR: 'debian'

## phase six

gitlab-geo-logcursor:
  extends: .gitlab-geo-logcursor
  needs:
    - gitlab-rails-ee

gitlab-sidekiq-ee:
  extends: .gitlab-sidekiq-ee
  needs:
    - gitlab-rails-ee
    - gitlab-python

gitlab-sidekiq-ce:
  extends: .gitlab-sidekiq-ce
  needs:
    - gitlab-rails-ce
    - gitlab-python

gitlab-toolbox-ee:
  extends: .gitlab-toolbox-ee
  needs:
    - gitlab-rails-ee
    - gitlab-python
    - gitaly

gitlab-toolbox-ce:
  extends: .gitlab-toolbox-ce
  needs:
    - gitlab-rails-ce
    - gitlab-python
    - gitaly

gitlab-webservice-ee:
  extends: .gitlab-webservice-ee
  needs:
    - gitlab-rails-ee
    - gitlab-python

gitlab-webservice-ce:
  extends: .gitlab-webservice-ce
  needs:
    - gitlab-rails-ce
    - gitlab-python

gitlab-workhorse-ee:
  extends: .gitlab-workhorse-ee
  needs:
    - gitlab-go
    - gitlab-exiftool
    - gitlab-rails-ee

gitlab-workhorse-ce:
  extends: .gitlab-workhorse-ce
  needs:
    - gitlab-go
    - gitlab-exiftool
    - gitlab-rails-ce
